diff --git a/nvmpi_dec.cpp b/nvmpi_dec.cpp
index 51278f6..d8cde51 100644
--- a/nvmpi_dec.cpp
+++ b/nvmpi_dec.cpp
@@ -1,539 +1,570 @@
-
-#include "nvmpi.h"
-#include "NvVideoDecoder.h"
-#include "nvbuf_utils.h"
-#include <vector>
-#include <iostream>
-#include <thread>
-#include <unistd.h>
-#include <queue>
-#include <mutex>
-#include <condition_variable>
-
-#define CHUNK_SIZE 4000000
-#define MAX_BUFFERS 32
-
-#define TEST_ERROR(condition, message, errorCode)    \
-	if (condition)                               \
-{                                                    \
-	std::cout<< message;			     \
-}
-
-using namespace std;
-
-struct nvmpictx
-{
-	NvVideoDecoder *dec{nullptr};
-	bool eos{false};
-	bool got_res_event{false};
-	int index{0};
-	unsigned int coded_width{0};
-	unsigned int coded_height{0};
-	int dst_dma_fd{0};
-	int numberCaptureBuffers{0};
-	int dmaBufferFileDescriptor[MAX_BUFFERS];
-	nvPixFormat out_pixfmt;
-	unsigned int decoder_pixfmt{0};
-	std::thread * dec_capture_loop{nullptr};
-	std::mutex* mutex{nullptr};
-	std::condition_variable* has_frame_cv{nullptr};
-	std::queue<int> * frame_pools{nullptr};
-	unsigned char * bufptr_0[MAX_BUFFERS];
-	unsigned char * bufptr_1[MAX_BUFFERS];
-	unsigned char * bufptr_2[MAX_BUFFERS];
-	unsigned int frame_size[MAX_NUM_PLANES];
-	unsigned int frame_linesize[MAX_NUM_PLANES];
-	unsigned long long timestamp[MAX_BUFFERS];
-};
-
-void respondToResolutionEvent(v4l2_format &format, v4l2_crop &crop,nvmpictx* ctx){
-	
-	int32_t minimumDecoderCaptureBuffers;
-	int ret=0;
-	NvBufferCreateParams input_params = {0};
-	NvBufferCreateParams cParams = {0};
-
-	ret = ctx->dec->capture_plane.getFormat(format);	
-	TEST_ERROR(ret < 0, "Error: Could not get format from decoder capture plane", ret);
-
-	ret = ctx->dec->capture_plane.getCrop(crop);
-	TEST_ERROR(ret < 0, "Error: Could not get crop from decoder capture plane", ret);
-
-	ctx->coded_width=crop.c.width;
-	ctx->coded_height=crop.c.height;
-
-	if(ctx->dst_dma_fd != -1)
-	{
-		NvBufferDestroy(ctx->dst_dma_fd);
-		ctx->dst_dma_fd = -1;
-	}
-
-	input_params.payloadType = NvBufferPayload_SurfArray;
-	input_params.width = crop.c.width;
-	input_params.height = crop.c.height;
-	input_params.layout = NvBufferLayout_Pitch;
-	input_params.colorFormat = ctx->out_pixfmt==NV_PIX_NV12?NvBufferColorFormat_NV12: NvBufferColorFormat_YUV420;
-	input_params.nvbuf_tag = NvBufferTag_VIDEO_DEC;
-
-	ctx->dec->capture_plane.deinitPlane();
-
-	for (int index = 0; index < ctx->numberCaptureBuffers; index++)
-	{
-		if (ctx->dmaBufferFileDescriptor[index] != 0)
-		{	
-			ret = NvBufferDestroy(ctx->dmaBufferFileDescriptor[index]);
-			TEST_ERROR(ret < 0, "Failed to Destroy NvBuffer", ret);
-		}
-
-	}
-
-
-	ret=ctx->dec->setCapturePlaneFormat(format.fmt.pix_mp.pixelformat,format.fmt.pix_mp.width,format.fmt.pix_mp.height);
-	TEST_ERROR(ret < 0, "Error in setting decoder capture plane format", ret);
-
-	ctx->dec->getMinimumCapturePlaneBuffers(minimumDecoderCaptureBuffers);
-	TEST_ERROR(ret < 0, "Error while getting value of minimum capture plane buffers",ret);
-
-	ctx->numberCaptureBuffers = minimumDecoderCaptureBuffers + 5;
-
-
-
-	switch (format.fmt.pix_mp.colorspace)
-	{
-		case V4L2_COLORSPACE_SMPTE170M:
-			if (format.fmt.pix_mp.quantization == V4L2_QUANTIZATION_DEFAULT)
-			{
-				// "Decoder colorspace ITU-R BT.601 with standard range luma (16-235)"
-				cParams.colorFormat = NvBufferColorFormat_NV12;
-			}
-			else
-			{
-				//"Decoder colorspace ITU-R BT.601 with extended range luma (0-255)";
-				cParams.colorFormat = NvBufferColorFormat_NV12_ER;
-			}
-			break;
-		case V4L2_COLORSPACE_REC709:
-			if (format.fmt.pix_mp.quantization == V4L2_QUANTIZATION_DEFAULT)
-			{
-				//"Decoder colorspace ITU-R BT.709 with standard range luma (16-235)";
-				cParams.colorFormat = NvBufferColorFormat_NV12_709;
-			}
-			else
-			{
-				//"Decoder colorspace ITU-R BT.709 with extended range luma (0-255)";
-				cParams.colorFormat = NvBufferColorFormat_NV12_709_ER;
-			}
-			break;
-		case V4L2_COLORSPACE_BT2020:
-			{
-				//"Decoder colorspace ITU-R BT.2020";
-				cParams.colorFormat = NvBufferColorFormat_NV12_2020;
-			}
-			break;
-		default:
-			if (format.fmt.pix_mp.quantization == V4L2_QUANTIZATION_DEFAULT)
-			{
-				//"Decoder colorspace ITU-R BT.601 with standard range luma (16-235)";
-				cParams.colorFormat = NvBufferColorFormat_NV12;
-			}
-			else
-			{
-				//"Decoder colorspace ITU-R BT.601 with extended range luma (0-255)";
-				cParams.colorFormat = NvBufferColorFormat_NV12_ER;
-			}
-			break;
-	}
-
-
-
-	ret = NvBufferCreateEx (&ctx->dst_dma_fd, &input_params);
-	TEST_ERROR(ret == -1, "create dst_dmabuf failed", error);
-
-	for (int index = 0; index < ctx->numberCaptureBuffers; index++)
-	{
-		cParams.width = crop.c.width;
-		cParams.height = crop.c.height;
-		cParams.layout = NvBufferLayout_BlockLinear;
-		cParams.payloadType = NvBufferPayload_SurfArray;
-		cParams.nvbuf_tag = NvBufferTag_VIDEO_DEC;
-
-		ret = NvBufferCreateEx(&ctx->dmaBufferFileDescriptor[index], &cParams);
-		TEST_ERROR(ret < 0, "Failed to create buffers", ret);
-
-	}	
-
-	ctx->dec->capture_plane.reqbufs(V4L2_MEMORY_DMABUF, ctx->numberCaptureBuffers);
-	TEST_ERROR(ret < 0, "Error in decoder capture plane streamon", ret);
-
-	ctx->dec->capture_plane.setStreamStatus(true);
-	TEST_ERROR(ret < 0, "Error in decoder capture plane streamon", ret);
-
-
-	for (uint32_t i = 0; i < ctx->dec->capture_plane.getNumBuffers(); i++)
-	{
-		struct v4l2_buffer v4l2_buf;
-		struct v4l2_plane planes[MAX_PLANES];
-
-		memset(&v4l2_buf, 0, sizeof(v4l2_buf));
-		memset(planes, 0, sizeof(planes));
-
-		v4l2_buf.index = i;
-		v4l2_buf.m.planes = planes;
-		v4l2_buf.type = V4L2_BUF_TYPE_VIDEO_CAPTURE;
-		v4l2_buf.memory = V4L2_MEMORY_DMABUF;
-		v4l2_buf.m.planes[0].m.fd = ctx->dmaBufferFileDescriptor[i];
-
-		ret = ctx->dec->capture_plane.qBuffer(v4l2_buf, NULL);
-		TEST_ERROR(ret < 0, "Error Qing buffer at output plane", ret);
-	}
-
-	ctx->got_res_event = true;
-}
-
-void *dec_capture_loop_fcn(void *arg){
-	nvmpictx* ctx=(nvmpictx*)arg;
-	
-	struct v4l2_format v4l2Format;
-	struct v4l2_crop v4l2Crop;
-	struct v4l2_event v4l2Event;
-	int ret,buf_index=0;
-
-	while (!(ctx->dec->isInError()||ctx->eos)){
-		NvBuffer *dec_buffer;
-
-		ret = ctx->dec->dqEvent(v4l2Event, ctx->got_res_event ? 0 : 500);
-		if (ret == 0)
-		{
-			switch (v4l2Event.type)
-			{
-				case V4L2_EVENT_RESOLUTION_CHANGE:
-					respondToResolutionEvent(v4l2Format, v4l2Crop,ctx);
-					continue;
-			}
-		}	
-
-		if (!ctx->got_res_event) {
-			continue;
-		}
-
-		while(!ctx->eos){
-			struct v4l2_buffer v4l2_buf;
-			struct v4l2_plane planes[MAX_PLANES];
-			v4l2_buf.m.planes = planes;
-
-			if (ctx->dec->capture_plane.dqBuffer(v4l2_buf, &dec_buffer, NULL, 0)){
-				if (errno == EAGAIN)
-				{
-					usleep(1000);
-				}
-				else
-				{
-
-					ERROR_MSG("Error while calling dequeue at capture plane");
-					ctx->eos=true;
-				}
-				break;
-
-			}
-
-			dec_buffer->planes[0].fd = ctx->dmaBufferFileDescriptor[v4l2_buf.index];
-			NvBufferRect src_rect, dest_rect;
-			src_rect.top = 0;
-			src_rect.left = 0;
-			src_rect.width = ctx->coded_width;
-			src_rect.height = ctx->coded_height;
-			dest_rect.top = 0;
-			dest_rect.left = 0;
-			dest_rect.width = ctx->coded_width;
-			dest_rect.height = ctx->coded_height;
-
-			NvBufferTransformParams transform_params;
-			memset(&transform_params,0,sizeof(transform_params));
-			transform_params.transform_flag = NVBUFFER_TRANSFORM_FILTER;
-			transform_params.transform_flip = NvBufferTransform_None;
-			transform_params.transform_filter = NvBufferTransform_Filter_Smart;
-			transform_params.src_rect = src_rect;
-			transform_params.dst_rect = dest_rect;
-
-			ctx->mutex->lock();
-
-			if(!ctx->eos){
-
-				ret = NvBufferTransform(dec_buffer->planes[0].fd, ctx->dst_dma_fd, &transform_params);
-				TEST_ERROR(ret==-1, "Transform failed",ret);
-
-				NvBufferParams parm;
-				ret = NvBufferGetParams(ctx->dst_dma_fd, &parm);
-
-				if(!ctx->frame_size[0]){
-
-					for(int index=0;index<MAX_BUFFERS;index++){
-						ctx->bufptr_0[index]=new unsigned char[parm.psize[0]];//Y
-						ctx->bufptr_1[index]=new unsigned char[parm.psize[1]];//UV or UU
-						ctx->bufptr_2[index]=new unsigned char[parm.psize[2]];//VV
-					}
-				}
-
-
-				ctx->frame_linesize[0]=parm.width[0];
-				ctx->frame_size[0]=parm.psize[0];
-
-				ctx->frame_linesize[1]=parm.width[1];
-				ctx->frame_size[1]=parm.psize[1];
-				ctx->frame_linesize[2]=parm.width[2];
-				ctx->frame_size[2]=parm.psize[2];
-
-
-				ret=NvBuffer2Raw(ctx->dst_dma_fd,0,parm.width[0],parm.height[0],ctx->bufptr_0[buf_index]);
-				ret=NvBuffer2Raw(ctx->dst_dma_fd,1,parm.width[1],parm.height[1],ctx->bufptr_1[buf_index]);	
-				if(ctx->out_pixfmt==NV_PIX_YUV420)
-					ret=NvBuffer2Raw(ctx->dst_dma_fd,2,parm.width[2],parm.height[2],ctx->bufptr_2[buf_index]);	
-
-				ctx->frame_pools->push(buf_index);
-				ctx->timestamp[buf_index]= (v4l2_buf.timestamp.tv_usec % 1000000) + (v4l2_buf.timestamp.tv_sec * 1000000UL);
-
-				buf_index=(buf_index+1)%MAX_BUFFERS;
-
-			}
-			
-			ctx->mutex->unlock();
-
-			if (ctx->eos) {
-				break;
-			}
-
-			ctx->has_frame_cv->notify_one();
-
-			v4l2_buf.m.planes[0].m.fd = ctx->dmaBufferFileDescriptor[v4l2_buf.index];
-			if (ctx->dec->capture_plane.qBuffer(v4l2_buf, NULL) < 0){
-				ERROR_MSG("Error while queueing buffer at decoder capture plane");
-			}
-		}
-	}
-
-	// Wake all waiting threads at EOS or decoder error
-	ctx->has_frame_cv->notify_all();
-}
-
-nvmpictx* nvmpi_create_decoder(nvCodingType codingType,nvPixFormat pixFormat){
-	
-	int ret;
-	log_level = LOG_LEVEL_INFO;
-
-	nvmpictx* ctx=new nvmpictx;
-
-	ctx->dec = NvVideoDecoder::createVideoDecoder("dec0");
-	TEST_ERROR(!ctx->dec, "Could not create decoder",ret);
-
-	ret=ctx->dec->subscribeEvent(V4L2_EVENT_RESOLUTION_CHANGE, 0, 0);
-	TEST_ERROR(ret < 0, "Could not subscribe to V4L2_EVENT_RESOLUTION_CHANGE", ret);
-
-	switch(codingType){
-		case NV_VIDEO_CodingH264:
-			ctx->decoder_pixfmt=V4L2_PIX_FMT_H264;
-			break;
-		case NV_VIDEO_CodingHEVC:
-			ctx->decoder_pixfmt=V4L2_PIX_FMT_H265;
-			break;
-		case NV_VIDEO_CodingMPEG4:
-			ctx->decoder_pixfmt=V4L2_PIX_FMT_MPEG4;
-			break;
-		case NV_VIDEO_CodingMPEG2:
-			ctx->decoder_pixfmt=V4L2_PIX_FMT_MPEG2;
-			break;
-		case NV_VIDEO_CodingVP8:
-			ctx->decoder_pixfmt=V4L2_PIX_FMT_VP8;
-			break;
-		case NV_VIDEO_CodingVP9:
-			ctx->decoder_pixfmt=V4L2_PIX_FMT_VP9;
-			break;
-		default:
-			ctx->decoder_pixfmt=V4L2_PIX_FMT_H264;
-			break;
-	}
-
-	ret=ctx->dec->setOutputPlaneFormat(ctx->decoder_pixfmt, CHUNK_SIZE);
-
-	TEST_ERROR(ret < 0, "Could not set output plane format", ret);
-
-	//ctx->nalu_parse_buffer = new char[CHUNK_SIZE];
-	ret = ctx->dec->setFrameInputMode(0);
-	TEST_ERROR(ret < 0, "Error in decoder setFrameInputMode for NALU", ret);
-
-	ret = ctx->dec->output_plane.setupPlane(V4L2_MEMORY_USERPTR, 10, false, true);
-	TEST_ERROR(ret < 0, "Error while setting up output plane", ret);
-
-	ctx->dec->output_plane.setStreamStatus(true);
-	TEST_ERROR(ret < 0, "Error in output plane stream on", ret);
-
-	ctx->out_pixfmt=pixFormat;
-	ctx->dst_dma_fd=-1;
-	ctx->eos=false;
-	ctx->got_res_event=false;
-	ctx->index=0;
-	ctx->frame_size[0]=0;
-	ctx->frame_pools=new std::queue<int>;
-	ctx->mutex = new std::mutex();
-	ctx->has_frame_cv = new std::condition_variable();
-	for(int index=0;index<MAX_BUFFERS;index++)
-		ctx->dmaBufferFileDescriptor[index]=0;
-	for(int index=0;index<MAX_BUFFERS;index++){
-		ctx->bufptr_0[index] = nullptr;
-		ctx->bufptr_1[index] = nullptr;
-		ctx->bufptr_2[index] = nullptr;
-	}
-	ctx->numberCaptureBuffers=0;
-	ctx->dec_capture_loop=new thread(dec_capture_loop_fcn,ctx);
-
-	return ctx;
-}
-
-
-
-
-int nvmpi_decoder_put_packet(nvmpictx* ctx,nvPacket* packet){
-	int ret;
-	
-	struct v4l2_buffer v4l2_buf;
-	struct v4l2_plane planes[MAX_PLANES];
-	NvBuffer *nvBuffer;
-
-	memset(&v4l2_buf, 0, sizeof(v4l2_buf));
-	memset(planes, 0, sizeof(planes));
-
-	v4l2_buf.m.planes = planes;
-
-	if (ctx->index < (int)ctx->dec->output_plane.getNumBuffers()) {
-		nvBuffer = ctx->dec->output_plane.getNthBuffer(ctx->index);
-	} else {
-		ret = ctx->dec->output_plane.dqBuffer(v4l2_buf, &nvBuffer, NULL, -1);
-		if (ret < 0) {
-			cout << "Error DQing buffer at output plane" << std::endl;
-			return false;
-		}
-	}
-
-	memcpy(nvBuffer->planes[0].data,packet->payload,packet->payload_size);
-	nvBuffer->planes[0].bytesused=packet->payload_size;
-
-
-
-	if (ctx->index < ctx->dec->output_plane.getNumBuffers())
-	{
-		v4l2_buf.index = ctx->index ;
-		v4l2_buf.m.planes = planes;
-	}
-
-	v4l2_buf.m.planes[0].bytesused = nvBuffer->planes[0].bytesused;
-
-	v4l2_buf.flags |= V4L2_BUF_FLAG_TIMESTAMP_COPY;
-	v4l2_buf.timestamp.tv_sec = packet->pts / 1000000;
-	v4l2_buf.timestamp.tv_usec = packet->pts % 1000000;
-
-
-	ret = ctx->dec->output_plane.qBuffer(v4l2_buf, NULL);
-	if (ret < 0) {
-		std::cout << "Error Qing buffer at output plane" << std::endl;
-		return false;
-	}
-
-	if (ctx->index < ctx->dec->output_plane.getNumBuffers())
-		ctx->index++;
-
-	if (v4l2_buf.m.planes[0].bytesused == 0) {
-		ctx->eos=true;
-		std::cout << "Input file read complete" << std::endl;
-	}
-
-
-	return 0;
-
-}
-
-
-int nvmpi_decoder_get_frame(nvmpictx* ctx,nvFrame* frame,bool wait){
-	
-	int ret,picture_index;
-	std::unique_lock<std::mutex> lock(*ctx->mutex);
-
-	if (wait) {
-		while (ctx->frame_pools->empty() && !ctx->eos && !ctx->dec->isInError()) {
-			ctx->has_frame_cv->wait(lock);
-		}
-	}
-
-	if (ctx->frame_pools->empty()) {
-		return -1;
-	}
-
-	picture_index=ctx->frame_pools->front();
-	ctx->frame_pools->pop();
-
-	frame->width=ctx->coded_width;
-	frame->height=ctx->coded_height;
-
-	frame->linesize[0]=ctx->frame_linesize[0];
-	frame->linesize[1]=ctx->frame_linesize[1];
-	frame->linesize[2]=ctx->frame_linesize[2];
-
-	frame->payload[0]=ctx->bufptr_0[picture_index];
-	frame->payload[1]=ctx->bufptr_1[picture_index];
-	frame->payload[2]=ctx->bufptr_2[picture_index];
-
-	frame->payload_size[0]=ctx->frame_size[0];
-	frame->payload_size[1]=ctx->frame_size[1];
-	frame->payload_size[2]=ctx->frame_size[2];
-	frame->timestamp=ctx->timestamp[picture_index];
-
-	return 0;
-
-}
-
-int nvmpi_decoder_close(nvmpictx* ctx){
-
-	ctx->mutex->lock();
-	ctx->eos=true;
-	ctx->mutex->unlock();
-	
-	ctx->dec->capture_plane.setStreamStatus(false);
-	
-	if (ctx->dec_capture_loop) {
-		ctx->dec_capture_loop->join();
-		delete ctx->dec_capture_loop;
-		ctx->dec_capture_loop = nullptr;
-	}
-
-	if(ctx->dst_dma_fd != -1)
-	{
-		NvBufferDestroy(ctx->dst_dma_fd);
-		ctx->dst_dma_fd = -1;
-	}
-
-	for (int index = 0; index < ctx->numberCaptureBuffers; index++)
-	{
-		if (ctx->dmaBufferFileDescriptor[index] != 0)
-		{	
-			int ret = NvBufferDestroy(ctx->dmaBufferFileDescriptor[index]);
-			TEST_ERROR(ret < 0, "Failed to Destroy NvBuffer", ret);
-		}
-
-	}
-	
-	delete ctx->dec; ctx->dec = nullptr;
-
-	for(int index=0;index<MAX_BUFFERS;index++){
-		delete[] ctx->bufptr_0[index];
-		delete[] ctx->bufptr_1[index];
-		delete[] ctx->bufptr_2[index];
-	}
-
-	delete ctx->mutex; ctx->mutex = nullptr;
-	delete ctx->has_frame_cv; ctx->has_frame_cv = nullptr;
-	delete ctx->frame_pools; ctx->frame_pools = nullptr;
-
-	delete ctx; ctx = nullptr;
-
-	return 0;
-}
-
-
+
+#include "nvmpi.h"
+#include "NvVideoDecoder.h"
+#include "nvbuf_utils.h"
+#include <vector>
+#include <iostream>
+#include <thread>
+#include <unistd.h>
+#include <queue>
+#include <mutex>
+#include <condition_variable>
+
+#define CHUNK_SIZE 4000000
+#define MAX_BUFFERS 32
+
+#define TEST_ERROR(condition, message, errorCode) \
+	if (condition)                                \
+	{                                             \
+		std::cout << message;                     \
+	}
+
+#define TEST_ERROR_EXIT(condition, heap_obj, ret) \
+	if (condition)                                \
+	{                                             \
+		if (heap_obj)                             \
+		{                                         \
+			delete heap_obj;                      \
+			heap_obj = nullptr;                   \
+		}                                         \
+		return ret;                               \
+	}
+
+using namespace std;
+
+struct nvmpictx
+{
+	NvVideoDecoder *dec{nullptr};
+	bool eos{false};
+	bool got_res_event{false};
+	int index{0};
+	unsigned int coded_width{0};
+	unsigned int coded_height{0};
+	int dst_dma_fd{0};
+	int numberCaptureBuffers{0};
+	int dmaBufferFileDescriptor[MAX_BUFFERS];
+	nvPixFormat out_pixfmt;
+	unsigned int decoder_pixfmt{0};
+	std::thread *dec_capture_loop{nullptr};
+	std::mutex *mutex{nullptr};
+	std::condition_variable *has_frame_cv{nullptr};
+	std::queue<int> *frame_pools{nullptr};
+	unsigned char *bufptr_0[MAX_BUFFERS];
+	unsigned char *bufptr_1[MAX_BUFFERS];
+	unsigned char *bufptr_2[MAX_BUFFERS];
+	unsigned int frame_size[MAX_NUM_PLANES];
+	unsigned int frame_linesize[MAX_NUM_PLANES];
+	unsigned long long timestamp[MAX_BUFFERS];
+};
+
+void respondToResolutionEvent(v4l2_format &format, v4l2_crop &crop, nvmpictx *ctx)
+{
+	int32_t minimumDecoderCaptureBuffers;
+	int ret = 0;
+	NvBufferCreateParams input_params = {0};
+	NvBufferCreateParams cParams = {0};
+
+	ret = ctx->dec->capture_plane.getFormat(format);
+	TEST_ERROR(ret < 0, "Error: Could not get format from decoder capture plane", ret);
+
+	ret = ctx->dec->capture_plane.getCrop(crop);
+	TEST_ERROR(ret < 0, "Error: Could not get crop from decoder capture plane", ret);
+
+	ctx->coded_width = crop.c.width;
+	ctx->coded_height = crop.c.height;
+
+	if (ctx->dst_dma_fd != -1)
+	{
+		NvBufferDestroy(ctx->dst_dma_fd);
+		ctx->dst_dma_fd = -1;
+	}
+
+	input_params.payloadType = NvBufferPayload_SurfArray;
+	input_params.width = crop.c.width;
+	input_params.height = crop.c.height;
+	input_params.layout = NvBufferLayout_Pitch;
+	input_params.colorFormat = ctx->out_pixfmt == NV_PIX_NV12 ? NvBufferColorFormat_NV12 : NvBufferColorFormat_YUV420;
+	input_params.nvbuf_tag = NvBufferTag_VIDEO_DEC;
+
+	ctx->dec->capture_plane.deinitPlane();
+
+	for (int index = 0; index < ctx->numberCaptureBuffers; index++)
+	{
+		if (ctx->dmaBufferFileDescriptor[index] != 0)
+		{
+			ret = NvBufferDestroy(ctx->dmaBufferFileDescriptor[index]);
+			TEST_ERROR(ret < 0, "Failed to Destroy NvBuffer", ret);
+		}
+	}
+
+	ret = ctx->dec->setCapturePlaneFormat(format.fmt.pix_mp.pixelformat, format.fmt.pix_mp.width, format.fmt.pix_mp.height);
+	TEST_ERROR(ret < 0, "Error in setting decoder capture plane format", ret);
+
+	ctx->dec->getMinimumCapturePlaneBuffers(minimumDecoderCaptureBuffers);
+	TEST_ERROR(ret < 0, "Error while getting value of minimum capture plane buffers", ret);
+
+	ctx->numberCaptureBuffers = minimumDecoderCaptureBuffers + 5;
+
+	switch (format.fmt.pix_mp.colorspace)
+	{
+	case V4L2_COLORSPACE_SMPTE170M:
+		if (format.fmt.pix_mp.quantization == V4L2_QUANTIZATION_DEFAULT)
+		{
+			// "Decoder colorspace ITU-R BT.601 with standard range luma (16-235)"
+			cParams.colorFormat = NvBufferColorFormat_NV12;
+		}
+		else
+		{
+			//"Decoder colorspace ITU-R BT.601 with extended range luma (0-255)";
+			cParams.colorFormat = NvBufferColorFormat_NV12_ER;
+		}
+		break;
+	case V4L2_COLORSPACE_REC709:
+		if (format.fmt.pix_mp.quantization == V4L2_QUANTIZATION_DEFAULT)
+		{
+			//"Decoder colorspace ITU-R BT.709 with standard range luma (16-235)";
+			cParams.colorFormat = NvBufferColorFormat_NV12_709;
+		}
+		else
+		{
+			//"Decoder colorspace ITU-R BT.709 with extended range luma (0-255)";
+			cParams.colorFormat = NvBufferColorFormat_NV12_709_ER;
+		}
+		break;
+	case V4L2_COLORSPACE_BT2020:
+	{
+		//"Decoder colorspace ITU-R BT.2020";
+		cParams.colorFormat = NvBufferColorFormat_NV12_2020;
+	}
+	break;
+	default:
+		if (format.fmt.pix_mp.quantization == V4L2_QUANTIZATION_DEFAULT)
+		{
+			//"Decoder colorspace ITU-R BT.601 with standard range luma (16-235)";
+			cParams.colorFormat = NvBufferColorFormat_NV12;
+		}
+		else
+		{
+			//"Decoder colorspace ITU-R BT.601 with extended range luma (0-255)";
+			cParams.colorFormat = NvBufferColorFormat_NV12_ER;
+		}
+		break;
+	}
+
+	ret = NvBufferCreateEx(&ctx->dst_dma_fd, &input_params);
+	TEST_ERROR(ret == -1, "create dst_dmabuf failed", error);
+
+	for (int index = 0; index < ctx->numberCaptureBuffers; index++)
+	{
+		cParams.width = crop.c.width;
+		cParams.height = crop.c.height;
+		cParams.layout = NvBufferLayout_BlockLinear;
+		cParams.payloadType = NvBufferPayload_SurfArray;
+		cParams.nvbuf_tag = NvBufferTag_VIDEO_DEC;
+
+		ret = NvBufferCreateEx(&ctx->dmaBufferFileDescriptor[index], &cParams);
+		TEST_ERROR(ret < 0, "Failed to create buffers", ret);
+	}
+
+	ctx->dec->capture_plane.reqbufs(V4L2_MEMORY_DMABUF, ctx->numberCaptureBuffers);
+	TEST_ERROR(ret < 0, "Error in decoder capture plane streamon", ret);
+
+	ctx->dec->capture_plane.setStreamStatus(true);
+	TEST_ERROR(ret < 0, "Error in decoder capture plane streamon", ret);
+
+	for (uint32_t i = 0; i < ctx->dec->capture_plane.getNumBuffers(); i++)
+	{
+		struct v4l2_buffer v4l2_buf;
+		struct v4l2_plane planes[MAX_PLANES];
+
+		memset(&v4l2_buf, 0, sizeof(v4l2_buf));
+		memset(planes, 0, sizeof(planes));
+
+		v4l2_buf.index = i;
+		v4l2_buf.m.planes = planes;
+		v4l2_buf.type = V4L2_BUF_TYPE_VIDEO_CAPTURE;
+		v4l2_buf.memory = V4L2_MEMORY_DMABUF;
+		v4l2_buf.m.planes[0].m.fd = ctx->dmaBufferFileDescriptor[i];
+
+		ret = ctx->dec->capture_plane.qBuffer(v4l2_buf, NULL);
+		TEST_ERROR(ret < 0, "Error Qing buffer at output plane", ret);
+	}
+
+	ctx->got_res_event = true;
+}
+
+void *dec_capture_loop_fcn(void *arg)
+{
+	nvmpictx *ctx = (nvmpictx *)arg;
+
+	struct v4l2_format v4l2Format;
+	struct v4l2_crop v4l2Crop;
+	struct v4l2_event v4l2Event;
+	int ret, buf_index = 0;
+
+	while (!(ctx->dec->isInError() || ctx->eos))
+	{
+		NvBuffer *dec_buffer;
+
+		ret = ctx->dec->dqEvent(v4l2Event, ctx->got_res_event ? 0 : 500);
+		if (ret == 0)
+		{
+			switch (v4l2Event.type)
+			{
+			case V4L2_EVENT_RESOLUTION_CHANGE:
+				respondToResolutionEvent(v4l2Format, v4l2Crop, ctx);
+				continue;
+			}
+		}
+
+		if (!ctx->got_res_event)
+		{
+			continue;
+		}
+
+		while (!ctx->eos)
+		{
+			struct v4l2_buffer v4l2_buf;
+			struct v4l2_plane planes[MAX_PLANES];
+			v4l2_buf.m.planes = planes;
+
+			if (ctx->dec->capture_plane.dqBuffer(v4l2_buf, &dec_buffer, NULL, 0))
+			{
+				if (errno == EAGAIN)
+				{
+					usleep(1000);
+				}
+				else
+				{
+
+					ERROR_MSG("Error while calling dequeue at capture plane");
+					ctx->eos = true;
+				}
+				break;
+			}
+
+			dec_buffer->planes[0].fd = ctx->dmaBufferFileDescriptor[v4l2_buf.index];
+			NvBufferRect src_rect, dest_rect;
+			src_rect.top = 0;
+			src_rect.left = 0;
+			src_rect.width = ctx->coded_width;
+			src_rect.height = ctx->coded_height;
+			dest_rect.top = 0;
+			dest_rect.left = 0;
+			dest_rect.width = ctx->coded_width;
+			dest_rect.height = ctx->coded_height;
+
+			NvBufferTransformParams transform_params;
+			memset(&transform_params, 0, sizeof(transform_params));
+			transform_params.transform_flag = NVBUFFER_TRANSFORM_FILTER;
+			transform_params.transform_flip = NvBufferTransform_None;
+			transform_params.transform_filter = NvBufferTransform_Filter_Smart;
+			transform_params.src_rect = src_rect;
+			transform_params.dst_rect = dest_rect;
+
+			ctx->mutex->lock();
+
+			if (!ctx->eos)
+			{
+
+				ret = NvBufferTransform(dec_buffer->planes[0].fd, ctx->dst_dma_fd, &transform_params);
+				TEST_ERROR(ret == -1, "Transform failed", ret);
+
+				NvBufferParams parm;
+				ret = NvBufferGetParams(ctx->dst_dma_fd, &parm);
+
+				if (!ctx->frame_size[0])
+				{
+
+					for (int index = 0; index < MAX_BUFFERS; index++)
+					{
+						ctx->bufptr_0[index] = new unsigned char[parm.psize[0]]; // Y
+						ctx->bufptr_1[index] = new unsigned char[parm.psize[1]]; // UV or UU
+						ctx->bufptr_2[index] = new unsigned char[parm.psize[2]]; // VV
+					}
+				}
+
+				ctx->frame_linesize[0] = parm.width[0];
+				ctx->frame_size[0] = parm.psize[0];
+
+				ctx->frame_linesize[1] = parm.width[1];
+				ctx->frame_size[1] = parm.psize[1];
+				ctx->frame_linesize[2] = parm.width[2];
+				ctx->frame_size[2] = parm.psize[2];
+
+				ret = NvBuffer2Raw(ctx->dst_dma_fd, 0, parm.width[0], parm.height[0], ctx->bufptr_0[buf_index]);
+				ret = NvBuffer2Raw(ctx->dst_dma_fd, 1, parm.width[1], parm.height[1], ctx->bufptr_1[buf_index]);
+				if (ctx->out_pixfmt == NV_PIX_YUV420)
+					ret = NvBuffer2Raw(ctx->dst_dma_fd, 2, parm.width[2], parm.height[2], ctx->bufptr_2[buf_index]);
+
+				ctx->frame_pools->push(buf_index);
+				ctx->timestamp[buf_index] = (v4l2_buf.timestamp.tv_usec % 1000000) + (v4l2_buf.timestamp.tv_sec * 1000000UL);
+
+				buf_index = (buf_index + 1) % MAX_BUFFERS;
+			}
+
+			ctx->mutex->unlock();
+
+			if (ctx->eos)
+			{
+				break;
+			}
+
+			ctx->has_frame_cv->notify_one();
+
+			v4l2_buf.m.planes[0].m.fd = ctx->dmaBufferFileDescriptor[v4l2_buf.index];
+			if (ctx->dec->capture_plane.qBuffer(v4l2_buf, NULL) < 0)
+			{
+				ERROR_MSG("Error while queueing buffer at decoder capture plane");
+			}
+		}
+	}
+
+	// Wake all waiting threads at EOS or decoder error
+	ctx->has_frame_cv->notify_all();
+}
+
+nvmpictx *nvmpi_create_decoder(nvCodingType codingType, nvPixFormat pixFormat)
+{
+	int ret;
+	log_level = LOG_LEVEL_INFO;
+
+	nvmpictx *ctx = new nvmpictx;
+
+	ctx->dec = NvVideoDecoder::createVideoDecoder("dec0");
+	TEST_ERROR(!ctx->dec, "Could not create decoder", ret);
+	TEST_ERROR_EXIT(!ctx->dec, ctx, ctx);
+
+	ret = ctx->dec->subscribeEvent(V4L2_EVENT_RESOLUTION_CHANGE, 0, 0);
+	TEST_ERROR(ret < 0, "Could not subscribe to V4L2_EVENT_RESOLUTION_CHANGE", ret);
+	TEST_ERROR_EXIT(ret < 0, ctx, ctx);
+
+	switch (codingType)
+	{
+	case NV_VIDEO_CodingH264:
+		ctx->decoder_pixfmt = V4L2_PIX_FMT_H264;
+		break;
+	case NV_VIDEO_CodingHEVC:
+		ctx->decoder_pixfmt = V4L2_PIX_FMT_H265;
+		break;
+	case NV_VIDEO_CodingMPEG4:
+		ctx->decoder_pixfmt = V4L2_PIX_FMT_MPEG4;
+		break;
+	case NV_VIDEO_CodingMPEG2:
+		ctx->decoder_pixfmt = V4L2_PIX_FMT_MPEG2;
+		break;
+	case NV_VIDEO_CodingVP8:
+		ctx->decoder_pixfmt = V4L2_PIX_FMT_VP8;
+		break;
+	case NV_VIDEO_CodingVP9:
+		ctx->decoder_pixfmt = V4L2_PIX_FMT_VP9;
+		break;
+	default:
+		ctx->decoder_pixfmt = V4L2_PIX_FMT_H264;
+		break;
+	}
+
+	ret = ctx->dec->setOutputPlaneFormat(ctx->decoder_pixfmt, CHUNK_SIZE);
+
+	TEST_ERROR(ret < 0, "Could not set output plane format", ret);
+	TEST_ERROR_EXIT(ret < 0, ctx, ctx);
+
+	// ctx->nalu_parse_buffer = new char[CHUNK_SIZE];
+	ret = ctx->dec->setFrameInputMode(0);
+	TEST_ERROR(ret < 0, "Error in decoder setFrameInputMode for NALU", ret);
+	TEST_ERROR_EXIT(ret < 0, ctx, ctx);
+
+	ret = ctx->dec->output_plane.setupPlane(V4L2_MEMORY_USERPTR, 10, false, true);
+	TEST_ERROR(ret < 0, "Error while setting up output plane", ret);
+	TEST_ERROR_EXIT(ret < 0, ctx, ctx);
+
+	ctx->dec->output_plane.setStreamStatus(true);
+	TEST_ERROR(ret < 0, "Error in output plane stream on", ret);
+	TEST_ERROR_EXIT(ret < 0, ctx, ctx);
+
+	ctx->out_pixfmt = pixFormat;
+	ctx->dst_dma_fd = -1;
+	ctx->eos = false;
+	ctx->got_res_event = false;
+	ctx->index = 0;
+	ctx->frame_size[0] = 0;
+	ctx->frame_pools = new std::queue<int>;
+	ctx->mutex = new std::mutex();
+	ctx->has_frame_cv = new std::condition_variable();
+	for (int index = 0; index < MAX_BUFFERS; index++)
+		ctx->dmaBufferFileDescriptor[index] = 0;
+	for (int index = 0; index < MAX_BUFFERS; index++)
+	{
+		ctx->bufptr_0[index] = nullptr;
+		ctx->bufptr_1[index] = nullptr;
+		ctx->bufptr_2[index] = nullptr;
+	}
+	ctx->numberCaptureBuffers = 0;
+	ctx->dec_capture_loop = new thread(dec_capture_loop_fcn, ctx);
+
+	return ctx;
+}
+
+int nvmpi_decoder_put_packet(nvmpictx *ctx, nvPacket *packet)
+{
+	int ret;
+
+	struct v4l2_buffer v4l2_buf;
+	struct v4l2_plane planes[MAX_PLANES];
+	NvBuffer *nvBuffer;
+
+	if (!ctx)
+		return -1;
+
+	memset(&v4l2_buf, 0, sizeof(v4l2_buf));
+	memset(planes, 0, sizeof(planes));
+
+	v4l2_buf.m.planes = planes;
+
+	if (ctx->index < (int)ctx->dec->output_plane.getNumBuffers())
+	{
+		nvBuffer = ctx->dec->output_plane.getNthBuffer(ctx->index);
+	}
+	else
+	{
+		ret = ctx->dec->output_plane.dqBuffer(v4l2_buf, &nvBuffer, NULL, -1);
+		if (ret < 0)
+		{
+			cout << "Error DQing buffer at output plane" << std::endl;
+			return ret;
+		}
+	}
+
+	memcpy(nvBuffer->planes[0].data, packet->payload, packet->payload_size);
+	nvBuffer->planes[0].bytesused = packet->payload_size;
+
+	if (ctx->index < ctx->dec->output_plane.getNumBuffers())
+	{
+		v4l2_buf.index = ctx->index;
+		v4l2_buf.m.planes = planes;
+	}
+
+	v4l2_buf.m.planes[0].bytesused = nvBuffer->planes[0].bytesused;
+
+	v4l2_buf.flags |= V4L2_BUF_FLAG_TIMESTAMP_COPY;
+	v4l2_buf.timestamp.tv_sec = packet->pts / 1000000;
+	v4l2_buf.timestamp.tv_usec = packet->pts % 1000000;
+
+	ret = ctx->dec->output_plane.qBuffer(v4l2_buf, NULL);
+	if (ret < 0)
+	{
+		std::cout << "Error Qing buffer at output plane" << std::endl;
+		return ret;
+	}
+
+	if (ctx->index < ctx->dec->output_plane.getNumBuffers())
+		ctx->index++;
+
+	if (v4l2_buf.m.planes[0].bytesused == 0)
+	{
+		ctx->eos = true;
+		std::cout << "Input file read complete" << std::endl;
+	}
+
+	return 0;
+}
+
+int nvmpi_decoder_get_frame(nvmpictx *ctx, nvFrame *frame, bool wait)
+{
+	int ret, picture_index;
+
+	if (!ctx)
+		return -1;
+
+	std::unique_lock<std::mutex> lock(*ctx->mutex);
+
+	if (wait)
+	{
+		while (ctx->frame_pools->empty() && !ctx->eos && !ctx->dec->isInError())
+		{
+			ctx->has_frame_cv->wait(lock);
+		}
+	}
+
+	if (ctx->frame_pools->empty())
+	{
+		return -1;
+	}
+
+	picture_index = ctx->frame_pools->front();
+	ctx->frame_pools->pop();
+
+	frame->width = ctx->coded_width;
+	frame->height = ctx->coded_height;
+
+	frame->linesize[0] = ctx->frame_linesize[0];
+	frame->linesize[1] = ctx->frame_linesize[1];
+	frame->linesize[2] = ctx->frame_linesize[2];
+
+	frame->payload[0] = ctx->bufptr_0[picture_index];
+	frame->payload[1] = ctx->bufptr_1[picture_index];
+	frame->payload[2] = ctx->bufptr_2[picture_index];
+
+	frame->payload_size[0] = ctx->frame_size[0];
+	frame->payload_size[1] = ctx->frame_size[1];
+	frame->payload_size[2] = ctx->frame_size[2];
+	frame->timestamp = ctx->timestamp[picture_index];
+
+	return 0;
+}
+
+int nvmpi_decoder_close(nvmpictx *ctx)
+{
+	if (!ctx)
+		return 0;
+
+	ctx->mutex->lock();
+	ctx->eos = true;
+	ctx->mutex->unlock();
+
+	ctx->dec->capture_plane.setStreamStatus(false);
+
+	if (ctx->dec_capture_loop)
+	{
+		ctx->dec_capture_loop->join();
+		delete ctx->dec_capture_loop;
+		ctx->dec_capture_loop = nullptr;
+	}
+
+	if (ctx->dst_dma_fd != -1)
+	{
+		NvBufferDestroy(ctx->dst_dma_fd);
+		ctx->dst_dma_fd = -1;
+	}
+
+	for (int index = 0; index < ctx->numberCaptureBuffers; index++)
+	{
+		if (ctx->dmaBufferFileDescriptor[index] != 0)
+		{
+			int ret = NvBufferDestroy(ctx->dmaBufferFileDescriptor[index]);
+			TEST_ERROR(ret < 0, "Failed to Destroy NvBuffer", ret);
+		}
+	}
+
+	delete ctx->dec;
+	ctx->dec = nullptr;
+
+	for (int index = 0; index < MAX_BUFFERS; index++)
+	{
+		delete[] ctx->bufptr_0[index];
+		delete[] ctx->bufptr_1[index];
+		delete[] ctx->bufptr_2[index];
+	}
+
+	delete ctx->mutex;
+	ctx->mutex = nullptr;
+	delete ctx->has_frame_cv;
+	ctx->has_frame_cv = nullptr;
+	delete ctx->frame_pools;
+	ctx->frame_pools = nullptr;
+
+	delete ctx;
+	ctx = nullptr;
+
+	return 0;
+}
diff --git a/nvmpi_enc.cpp b/nvmpi_enc.cpp
index 43f267d..af272b3 100644
--- a/nvmpi_enc.cpp
+++ b/nvmpi_enc.cpp
@@ -7,21 +7,21 @@
 #include <unistd.h>
 #include <queue>
 
-#define CHUNK_SIZE 2*1024*1024
+#define CHUNK_SIZE 2 * 1024 * 1024
 #define MAX_BUFFERS 32
-#define TEST_ERROR(condition, message, errorCode)    \
-	if (condition)                               \
-{                                                    \
-	std::cout<< message;                         \
-}
-
+#define TEST_ERROR(condition, message, errorCode) \
+	if (condition)                                \
+	{                                             \
+		std::cout << message;                     \
+	}
 
 using namespace std;
 
-struct nvmpictx{
+struct nvmpictx
+{
 	NvVideoEncoder *enc;
 	int index;
-	std::queue<int> * packet_pools;
+	std::queue<int> *packet_pools;
 	uint32_t width;
 	uint32_t height;
 	uint32_t profile;
@@ -46,19 +46,19 @@ struct nvmpictx{
 
 	uint32_t packets_buf_size;
 	uint32_t packets_num;
-	unsigned char * packets[MAX_BUFFERS];
+	unsigned char *packets[MAX_BUFFERS];
 	uint32_t packets_size[MAX_BUFFERS];
 	bool packets_keyflag[MAX_BUFFERS];
 	uint64_t timestamp[MAX_BUFFERS];
 	int buf_index;
 };
 
+static bool encoder_capture_plane_dq_callback(struct v4l2_buffer *v4l2_buf, NvBuffer *buffer, NvBuffer *shared_buffer, void *arg)
+{
 
-static bool encoder_capture_plane_dq_callback(struct v4l2_buffer *v4l2_buf, NvBuffer * buffer, NvBuffer * shared_buffer, void *arg){
-
-	nvmpictx *ctx = (nvmpictx *) arg;
+	nvmpictx *ctx = (nvmpictx *)arg;
 	NvVideoEncoder *enc = ctx->enc;
-	//uint32_t frame_num = ctx->enc->capture_plane.getTotalDequeuedBuffers() - 1;
+	// uint32_t frame_num = ctx->enc->capture_plane.getTotalDequeuedBuffers() - 1;
 
 	if (v4l2_buf == NULL)
 	{
@@ -72,18 +72,20 @@ static bool encoder_capture_plane_dq_callback(struct v4l2_buffer *v4l2_buf, NvBu
 		return false;
 	}
 
-	if(ctx->packets_buf_size < buffer->planes[0].bytesused){
+	if (ctx->packets_buf_size < buffer->planes[0].bytesused)
+	{
 
-		ctx->packets_buf_size=buffer->planes[0].bytesused;
+		ctx->packets_buf_size = buffer->planes[0].bytesused;
 
-		for(int index=0;index< ctx->packets_num;index++){
+		for (int index = 0; index < ctx->packets_num; index++)
+		{
 			delete[] ctx->packets[index];
-			ctx->packets[index]=new unsigned char[ctx->packets_buf_size];	
+			ctx->packets[index] = new unsigned char[ctx->packets_buf_size];
 		}
 	}
 
-	ctx->packets_size[ctx->buf_index]=buffer->planes[0].bytesused;
-	memcpy(ctx->packets[ctx->buf_index],buffer->planes[0].data,buffer->planes[0].bytesused);
+	ctx->packets_size[ctx->buf_index] = buffer->planes[0].bytesused;
+	memcpy(ctx->packets[ctx->buf_index], buffer->planes[0].data, buffer->planes[0].bytesused);
 
 	ctx->timestamp[ctx->buf_index] = (v4l2_buf->timestamp.tv_usec % 1000000) + (v4l2_buf->timestamp.tv_sec * 1000000UL);
 
@@ -91,13 +93,16 @@ static bool encoder_capture_plane_dq_callback(struct v4l2_buffer *v4l2_buf, NvBu
 
 	v4l2_ctrl_videoenc_outputbuf_metadata enc_metadata;
 	ctx->enc->getMetadata(v4l2_buf->index, enc_metadata);
-	if(enc_metadata.KeyFrame){
-		ctx->packets_keyflag[ctx->buf_index]=true;
-	}else{
-		ctx->packets_keyflag[ctx->buf_index]=false;
+	if (enc_metadata.KeyFrame)
+	{
+		ctx->packets_keyflag[ctx->buf_index] = true;
+	}
+	else
+	{
+		ctx->packets_keyflag[ctx->buf_index] = false;
 	}
 
-	ctx->buf_index=(ctx->buf_index+1)%ctx->packets_num;	
+	ctx->buf_index = (ctx->buf_index + 1) % ctx->packets_num;
 
 	if (ctx->enc->capture_plane.qBuffer(*v4l2_buf, NULL) < 0)
 	{
@@ -109,161 +114,164 @@ static bool encoder_capture_plane_dq_callback(struct v4l2_buffer *v4l2_buf, NvBu
 	return true;
 }
 
-
-nvmpictx* nvmpi_create_encoder(nvCodingType codingType,nvEncParam * param){
+nvmpictx *nvmpi_create_encoder(nvCodingType codingType, nvEncParam *param)
+{
 
 	int ret;
 	log_level = LOG_LEVEL_INFO;
-	nvmpictx *ctx=new nvmpictx;
-	ctx->index=0;
-	ctx->width=param->width;
-	ctx->height=param->height;
-	ctx->enableLossless=false;
-	ctx->bitrate=param->bitrate;
-	ctx->ratecontrol = V4L2_MPEG_VIDEO_BITRATE_MODE_CBR;	
+	nvmpictx *ctx = new nvmpictx;
+	ctx->index = 0;
+	ctx->width = param->width;
+	ctx->height = param->height;
+	ctx->enableLossless = false;
+	ctx->bitrate = param->bitrate;
+	ctx->ratecontrol = V4L2_MPEG_VIDEO_BITRATE_MODE_CBR;
 	ctx->idr_interval = param->idr_interval;
 	ctx->fps_n = param->fps_n;
 	ctx->fps_d = param->fps_d;
 	ctx->iframe_interval = param->iframe_interval;
-	ctx->packet_pools=new std::queue<int>;
-	ctx->buf_index=0;
-	ctx->enable_extended_colorformat=false;
-	ctx->packets_num=param->capture_num;
-	ctx->qmax=param->qmax;
-	ctx->qmin=param->qmin;
-	ctx->num_b_frames=param->max_b_frames;
-	ctx->num_reference_frames=param->refs;
-	ctx->insert_sps_pps_at_idr=(param->insert_spspps_idr==1)?true:false;
-
-	switch(param->profile){
-		case 77://FF_PROFILE_H264_MAIN
-			ctx->profile=V4L2_MPEG_VIDEO_H264_PROFILE_MAIN;
-			break;
-		case 66://FF_PROFILE_H264_BASELINE
-			ctx->profile=V4L2_MPEG_VIDEO_H264_PROFILE_BASELINE;
-			break;
-		case 100://FF_PROFILE_H264_HIGH
-			ctx->profile=V4L2_MPEG_VIDEO_H264_PROFILE_HIGH;
-			break;
-
-		default:
-			ctx->profile=V4L2_MPEG_VIDEO_H264_PROFILE_MAIN;
-			break;
-
+	ctx->packet_pools = new std::queue<int>;
+	ctx->buf_index = 0;
+	ctx->enable_extended_colorformat = false;
+	ctx->packets_num = param->capture_num;
+	ctx->qmax = param->qmax;
+	ctx->qmin = param->qmin;
+	ctx->num_b_frames = param->max_b_frames;
+	ctx->num_reference_frames = param->refs;
+	ctx->insert_sps_pps_at_idr = (param->insert_spspps_idr == 1) ? true : false;
+
+	switch (param->profile)
+	{
+	case 77: // FF_PROFILE_H264_MAIN
+		ctx->profile = V4L2_MPEG_VIDEO_H264_PROFILE_MAIN;
+		break;
+	case 66: // FF_PROFILE_H264_BASELINE
+		ctx->profile = V4L2_MPEG_VIDEO_H264_PROFILE_BASELINE;
+		break;
+	case 100: // FF_PROFILE_H264_HIGH
+		ctx->profile = V4L2_MPEG_VIDEO_H264_PROFILE_HIGH;
+		break;
+
+	default:
+		ctx->profile = V4L2_MPEG_VIDEO_H264_PROFILE_MAIN;
+		break;
 	}
 
-	switch(param->level){
-		case 10:
-			ctx->level=V4L2_MPEG_VIDEO_H264_LEVEL_1_0;
-			break;
-		case 11:
-			ctx->level=V4L2_MPEG_VIDEO_H264_LEVEL_1_1;
-			break;
-		case 12:
-			ctx->level=V4L2_MPEG_VIDEO_H264_LEVEL_1_2;
-			break;
-		case 13:
-			ctx->level=V4L2_MPEG_VIDEO_H264_LEVEL_1_3;
-			break;
-		case 20:
-			ctx->level=V4L2_MPEG_VIDEO_H264_LEVEL_2_0;
-			break;
-		case 21:
-			ctx->level=V4L2_MPEG_VIDEO_H264_LEVEL_2_1;
-			break;
-		case 22:
-			ctx->level=V4L2_MPEG_VIDEO_H264_LEVEL_2_2;
-			break;
-		case 30:
-			ctx->level=V4L2_MPEG_VIDEO_H264_LEVEL_3_0;
-			break;
-		case 31:
-			ctx->level=V4L2_MPEG_VIDEO_H264_LEVEL_3_1;
-			break;
-		case 32:
-			ctx->level=V4L2_MPEG_VIDEO_H264_LEVEL_3_2;
-			break;
-		case 40:
-			ctx->level=V4L2_MPEG_VIDEO_H264_LEVEL_4_0;
-			break;
-		case 41:
-			ctx->level=V4L2_MPEG_VIDEO_H264_LEVEL_4_1;
-			break;
-		case 42:
-			ctx->level=V4L2_MPEG_VIDEO_H264_LEVEL_4_2;
-			break;
-		case 50:
-			ctx->level=V4L2_MPEG_VIDEO_H264_LEVEL_5_0;
-			break;
-		case 51:
-			ctx->level=V4L2_MPEG_VIDEO_H264_LEVEL_5_1;
-			break;
-		default:
-			ctx->level=V4L2_MPEG_VIDEO_H264_LEVEL_5_1;
-			break;	
+	switch (param->level)
+	{
+	case 10:
+		ctx->level = V4L2_MPEG_VIDEO_H264_LEVEL_1_0;
+		break;
+	case 11:
+		ctx->level = V4L2_MPEG_VIDEO_H264_LEVEL_1_1;
+		break;
+	case 12:
+		ctx->level = V4L2_MPEG_VIDEO_H264_LEVEL_1_2;
+		break;
+	case 13:
+		ctx->level = V4L2_MPEG_VIDEO_H264_LEVEL_1_3;
+		break;
+	case 20:
+		ctx->level = V4L2_MPEG_VIDEO_H264_LEVEL_2_0;
+		break;
+	case 21:
+		ctx->level = V4L2_MPEG_VIDEO_H264_LEVEL_2_1;
+		break;
+	case 22:
+		ctx->level = V4L2_MPEG_VIDEO_H264_LEVEL_2_2;
+		break;
+	case 30:
+		ctx->level = V4L2_MPEG_VIDEO_H264_LEVEL_3_0;
+		break;
+	case 31:
+		ctx->level = V4L2_MPEG_VIDEO_H264_LEVEL_3_1;
+		break;
+	case 32:
+		ctx->level = V4L2_MPEG_VIDEO_H264_LEVEL_3_2;
+		break;
+	case 40:
+		ctx->level = V4L2_MPEG_VIDEO_H264_LEVEL_4_0;
+		break;
+	case 41:
+		ctx->level = V4L2_MPEG_VIDEO_H264_LEVEL_4_1;
+		break;
+	case 42:
+		ctx->level = V4L2_MPEG_VIDEO_H264_LEVEL_4_2;
+		break;
+	case 50:
+		ctx->level = V4L2_MPEG_VIDEO_H264_LEVEL_5_0;
+		break;
+	case 51:
+		ctx->level = V4L2_MPEG_VIDEO_H264_LEVEL_5_1;
+		break;
+	default:
+		ctx->level = V4L2_MPEG_VIDEO_H264_LEVEL_5_1;
+		break;
 	}
 
-	switch(param->hw_preset_type){
-		case 1:
-			ctx->hw_preset_type = V4L2_ENC_HW_PRESET_ULTRAFAST;
-			break;
-		case 2:
-			ctx->hw_preset_type = V4L2_ENC_HW_PRESET_FAST;
-			break;
-		case 3:
-			ctx->hw_preset_type = V4L2_ENC_HW_PRESET_MEDIUM;
-			break;
-		case 4:
-			ctx->hw_preset_type = V4L2_ENC_HW_PRESET_SLOW;
-			break;
-		default:
-			ctx->hw_preset_type = V4L2_ENC_HW_PRESET_MEDIUM;
-			break;
-
+	switch (param->hw_preset_type)
+	{
+	case 1:
+		ctx->hw_preset_type = V4L2_ENC_HW_PRESET_ULTRAFAST;
+		break;
+	case 2:
+		ctx->hw_preset_type = V4L2_ENC_HW_PRESET_FAST;
+		break;
+	case 3:
+		ctx->hw_preset_type = V4L2_ENC_HW_PRESET_MEDIUM;
+		break;
+	case 4:
+		ctx->hw_preset_type = V4L2_ENC_HW_PRESET_SLOW;
+		break;
+	default:
+		ctx->hw_preset_type = V4L2_ENC_HW_PRESET_MEDIUM;
+		break;
 	}
 
+	if (param->enableLossless)
+		ctx->enableLossless = true;
 
+	if (param->mode_vbr)
+		ctx->ratecontrol = V4L2_MPEG_VIDEO_BITRATE_MODE_VBR;
 
-	if(param->enableLossless)
-		ctx->enableLossless=true;
-
-	if(param->mode_vbr)
-		ctx->ratecontrol=V4L2_MPEG_VIDEO_BITRATE_MODE_VBR;
-
-	ctx->packets_buf_size=CHUNK_SIZE;
+	ctx->packets_buf_size = CHUNK_SIZE;
 
-	for(int index=0;index<MAX_BUFFERS;index++)
-		ctx->packets[index]=new unsigned char[ctx->packets_buf_size];
+	for (int index = 0; index < MAX_BUFFERS; index++)
+		ctx->packets[index] = new unsigned char[ctx->packets_buf_size];
 
-	if(codingType==NV_VIDEO_CodingH264){
-		ctx->encoder_pixfmt=V4L2_PIX_FMT_H264;
-	}else if(codingType==NV_VIDEO_CodingHEVC){
-		ctx->encoder_pixfmt=V4L2_PIX_FMT_H265;
+	if (codingType == NV_VIDEO_CodingH264)
+	{
+		ctx->encoder_pixfmt = V4L2_PIX_FMT_H264;
+	}
+	else if (codingType == NV_VIDEO_CodingHEVC)
+	{
+		ctx->encoder_pixfmt = V4L2_PIX_FMT_H265;
 	}
-	ctx->enc=NvVideoEncoder::createVideoEncoder("enc0");
-	TEST_ERROR(!ctx->enc, "Could not create encoder",ret);
+	ctx->enc = NvVideoEncoder::createVideoEncoder("enc0");
+	TEST_ERROR(!ctx->enc, "Could not create encoder", ret);
 
-	ret = ctx->enc->setCapturePlaneFormat(ctx->encoder_pixfmt, ctx->width,ctx->height, CHUNK_SIZE);
+	ret = ctx->enc->setCapturePlaneFormat(ctx->encoder_pixfmt, ctx->width, ctx->height, CHUNK_SIZE);
 
 	TEST_ERROR(ret < 0, "Could not set output plane format", ret);
 
 	switch (ctx->profile)
 	{
-		case V4L2_MPEG_VIDEO_H265_PROFILE_MAIN10:
-			ctx->raw_pixfmt = V4L2_PIX_FMT_P010M;
-			break;
-		case V4L2_MPEG_VIDEO_H265_PROFILE_MAIN:
-		default:
-			ctx->raw_pixfmt = V4L2_PIX_FMT_YUV420M;
+	case V4L2_MPEG_VIDEO_H265_PROFILE_MAIN10:
+		ctx->raw_pixfmt = V4L2_PIX_FMT_P010M;
+		break;
+	case V4L2_MPEG_VIDEO_H265_PROFILE_MAIN:
+	default:
+		ctx->raw_pixfmt = V4L2_PIX_FMT_YUV420M;
 	}
 
 	if (ctx->enableLossless && codingType == NV_VIDEO_CodingH264)
 	{
 		ctx->profile = V4L2_MPEG_VIDEO_H264_PROFILE_HIGH_444_PREDICTIVE;
-		ret = ctx->enc->setOutputPlaneFormat(V4L2_PIX_FMT_YUV444M, ctx->width,ctx->height);
+		ret = ctx->enc->setOutputPlaneFormat(V4L2_PIX_FMT_YUV444M, ctx->width, ctx->height);
 	}
-	else{
-		ret = ctx->enc->setOutputPlaneFormat(ctx->raw_pixfmt, ctx->width,ctx->height);
+	else
+	{
+		ret = ctx->enc->setOutputPlaneFormat(ctx->raw_pixfmt, ctx->width, ctx->height);
 	}
 
 	TEST_ERROR(ret < 0, "Could not set output plane format", ret);
@@ -271,42 +279,46 @@ nvmpictx* nvmpi_create_encoder(nvCodingType codingType,nvEncParam * param){
 	ret = ctx->enc->setBitrate(ctx->bitrate);
 	TEST_ERROR(ret < 0, "Could not set encoder bitrate", ret);
 
-	ret=ctx->enc->setHWPresetType(ctx->hw_preset_type);
+	ret = ctx->enc->setHWPresetType(ctx->hw_preset_type);
 	TEST_ERROR(ret < 0, "Could not set encoder HW Preset Type", ret);
 
-	if(ctx->num_reference_frames){
+	if (ctx->num_reference_frames)
+	{
 		ret = ctx->enc->setNumReferenceFrames(ctx->num_reference_frames);
 		TEST_ERROR(ret < 0, "Could not set num reference frames", ret);
 	}
 
-	if(ctx->num_b_frames != (uint32_t) -1 && codingType == NV_VIDEO_CodingH264 ){
+	if (ctx->num_b_frames != (uint32_t)-1 && codingType == NV_VIDEO_CodingH264)
+	{
 		ret = ctx->enc->setNumBFrames(ctx->num_b_frames);
 		TEST_ERROR(ret < 0, "Could not set number of B Frames", ret);
 	}
 
-
 	if (codingType == NV_VIDEO_CodingH264 || codingType == NV_VIDEO_CodingHEVC)
 	{
 		ret = ctx->enc->setProfile(ctx->profile);
 		TEST_ERROR(ret < 0, "Could not set encoder profile", ret);
 	}
 
-	if( codingType== NV_VIDEO_CodingH264){
+	if (codingType == NV_VIDEO_CodingH264)
+	{
 		ret = ctx->enc->setLevel(ctx->level);
 		TEST_ERROR(ret < 0, "Could not set encoder level", ret);
 	}
 
-
-	if (ctx->enableLossless){
+	if (ctx->enableLossless)
+	{
 		ret = ctx->enc->setConstantQp(0);
 		TEST_ERROR(ret < 0, "Could not set encoder constant qp=0", ret);
-
-	}else{
+	}
+	else
+	{
 
 		ret = ctx->enc->setRateControlMode(ctx->ratecontrol);
 		TEST_ERROR(ret < 0, "Could not set encoder rate control mode", ret);
 
-		if (ctx->ratecontrol == V4L2_MPEG_VIDEO_BITRATE_MODE_VBR){
+		if (ctx->ratecontrol == V4L2_MPEG_VIDEO_BITRATE_MODE_VBR)
+		{
 
 			uint32_t peak_bitrate;
 			if (ctx->peak_bitrate < ctx->bitrate)
@@ -321,13 +333,15 @@ nvmpictx* nvmpi_create_encoder(nvCodingType codingType,nvEncParam * param){
 	ret = ctx->enc->setIDRInterval(ctx->idr_interval);
 	TEST_ERROR(ret < 0, "Could not set encoder IDR interval", ret);
 
-	if(ctx->qmax>0 ||ctx->qmin >0){
-		ctx->enc->setQpRange(ctx->qmin, ctx->qmax, ctx->qmin,ctx->qmax, ctx->qmin, ctx->qmax);	
+	if (ctx->qmax > 0 || ctx->qmin > 0)
+	{
+		ctx->enc->setQpRange(ctx->qmin, ctx->qmax, ctx->qmin, ctx->qmax, ctx->qmin, ctx->qmax);
 	}
 	ret = ctx->enc->setIFrameInterval(ctx->iframe_interval);
 	TEST_ERROR(ret < 0, "Could not set encoder I-Frame interval", ret);
-	
-	if(ctx->insert_sps_pps_at_idr){
+
+	if (ctx->insert_sps_pps_at_idr)
+	{
 		ret = ctx->enc->setInsertSpsPpsAtIdrEnabled(true);
 		TEST_ERROR(ret < 0, "Could not set insertSPSPPSAtIDR", ret);
 	}
@@ -341,7 +355,7 @@ nvmpictx* nvmpi_create_encoder(nvCodingType codingType,nvEncParam * param){
 	ret = ctx->enc->capture_plane.setupPlane(V4L2_MEMORY_MMAP, ctx->packets_num, true, false);
 	TEST_ERROR(ret < 0, "Could not setup capture plane", ret);
 
-	ret = ctx->enc->subscribeEvent(V4L2_EVENT_EOS,0,0);
+	ret = ctx->enc->subscribeEvent(V4L2_EVENT_EOS, 0, 0);
 	TEST_ERROR(ret < 0, "Could not subscribe EOS event", ret);
 
 	ret = ctx->enc->output_plane.setStreamStatus(true);
@@ -350,13 +364,13 @@ nvmpictx* nvmpi_create_encoder(nvCodingType codingType,nvEncParam * param){
 	ret = ctx->enc->capture_plane.setStreamStatus(true);
 	TEST_ERROR(ret < 0, "Error in capture plane streamon", ret);
 
-
 	ctx->enc->capture_plane.setDQThreadCallback(encoder_capture_plane_dq_callback);
 
 	ctx->enc->capture_plane.startDQThread(ctx);
 
 	// Enqueue all the empty capture plane buffers
-	for (uint32_t i = 0; i < ctx->enc->capture_plane.getNumBuffers(); i++){
+	for (uint32_t i = 0; i < ctx->enc->capture_plane.getNumBuffers(); i++)
+	{
 		struct v4l2_buffer v4l2_buf;
 		struct v4l2_plane planes[MAX_PLANES];
 		memset(&v4l2_buf, 0, sizeof(v4l2_buf));
@@ -367,14 +381,38 @@ nvmpictx* nvmpi_create_encoder(nvCodingType codingType,nvEncParam * param){
 
 		ret = ctx->enc->capture_plane.qBuffer(v4l2_buf, NULL);
 		TEST_ERROR(ret < 0, "Error while queueing buffer at capture plane", ret);
-
 	}
 
 	return ctx;
 }
 
+static void copy_image_plane(unsigned char *dst, const unsigned char *src, int dstPitch, int srcPitch, int height, uint32_t *byteCopied)
+{
+	if (!dst || !src)
+	{
+		return;
+	}
+	if (dstPitch == srcPitch)
+	{
+		*byteCopied = srcPitch * height;
+		memcpy(dst, src, *byteCopied);
+	}
+	else
+	{
+		int pitch = min(dstPitch, srcPitch);
+		*byteCopied = 0;
+		for (int i = 0; i < height; i++)
+		{
+			memcpy(dst, src, pitch);
+			dst += dstPitch;
+			src += srcPitch;
+			*byteCopied += pitch;
+		}
+	}
+}
 
-int nvmpi_encoder_put_frame(nvmpictx* ctx,nvFrame* frame){
+int nvmpi_encoder_put_frame(nvmpictx *ctx, nvFrame *frame)
+{
 	int ret;
 
 	struct v4l2_buffer v4l2_buf;
@@ -386,30 +424,29 @@ int nvmpi_encoder_put_frame(nvmpictx* ctx,nvFrame* frame){
 
 	v4l2_buf.m.planes = planes;
 
-	if(ctx->enc->isInError())
+	if (ctx->enc->isInError())
 		return -1;
 
-	if(ctx->index < ctx->enc->output_plane.getNumBuffers()){
+	if (ctx->index < ctx->enc->output_plane.getNumBuffers())
+	{
 
-		nvBuffer=ctx->enc->output_plane.getNthBuffer(ctx->index);
-		v4l2_buf.index = ctx->index ;
+		nvBuffer = ctx->enc->output_plane.getNthBuffer(ctx->index);
+		v4l2_buf.index = ctx->index;
 		ctx->index++;
-
-	}else{
+	}
+	else
+	{
 		ret = ctx->enc->output_plane.dqBuffer(v4l2_buf, &nvBuffer, NULL, -1);
-		if (ret < 0) {
+		if (ret < 0)
+		{
 			cout << "Error DQing buffer at output plane" << std::endl;
 			return false;
 		}
-
 	}
 
-	memcpy(nvBuffer->planes[0].data,frame->payload[0],frame->payload_size[0]);
-	memcpy(nvBuffer->planes[1].data,frame->payload[1],frame->payload_size[1]);
-	memcpy(nvBuffer->planes[2].data,frame->payload[2],frame->payload_size[2]);
-	nvBuffer->planes[0].bytesused=frame->payload_size[0];
-	nvBuffer->planes[1].bytesused=frame->payload_size[1];
-	nvBuffer->planes[2].bytesused=frame->payload_size[2];
+	copy_image_plane(nvBuffer->planes[0].data, frame->payload[0], nvBuffer->planes[0].fmt.stride, frame->linesize[0], frame->height, &nvBuffer->planes[0].bytesused);
+	copy_image_plane(nvBuffer->planes[1].data, frame->payload[1], nvBuffer->planes[1].fmt.stride, frame->linesize[1], frame->height >> 1, &nvBuffer->planes[1].bytesused);
+	copy_image_plane(nvBuffer->planes[2].data, frame->payload[2], nvBuffer->planes[2].fmt.stride, frame->linesize[2], frame->height >> 1, &nvBuffer->planes[2].bytesused);
 
 	v4l2_buf.flags |= V4L2_BUF_FLAG_TIMESTAMP_COPY;
 	v4l2_buf.timestamp.tv_usec = frame->timestamp % 1000000;
@@ -421,34 +458,36 @@ int nvmpi_encoder_put_frame(nvmpictx* ctx,nvFrame* frame){
 	return 0;
 }
 
-int nvmpi_encoder_get_packet(nvmpictx* ctx,nvPacket* packet){
+int nvmpi_encoder_get_packet(nvmpictx *ctx, nvPacket *packet)
+{
 
-	int ret,packet_index;
+	int ret, packet_index;
 
-	if(ctx->packet_pools->empty())
+	if (ctx->packet_pools->empty())
 		return -1;
 
-	packet_index= ctx->packet_pools->front();
+	packet_index = ctx->packet_pools->front();
 
 	auto ts = ctx->timestamp[packet_index];
 	auto size = ctx->packets_size[packet_index];
-	if((ts > 0) && (size == 0)) // Old packet, but 0-0 skip!
+	if ((ts > 0) && (size == 0)) // Old packet, but 0-0 skip!
 	{
 		return -1;
 	}
 
-	packet->payload=ctx->packets[packet_index];
-	packet->pts=ts;
+	packet->payload = ctx->packets[packet_index];
+	packet->pts = ts;
 
-	packet->payload_size=size;
-	if(ctx->packets_keyflag[packet_index])
-		packet->flags|= 0x0001;//AV_PKT_FLAG_KEY 0x0001
+	packet->payload_size = size;
+	if (ctx->packets_keyflag[packet_index])
+		packet->flags |= 0x0001;		 // AV_PKT_FLAG_KEY 0x0001
 	ctx->packets_size[packet_index] = 0; // mark as readed
 	ctx->packet_pools->pop();
 	return 0;
 }
 
-int nvmpi_encoder_close(nvmpictx* ctx){
+int nvmpi_encoder_close(nvmpictx *ctx)
+{
 
 	ctx->enc->capture_plane.stopDQThread();
 	ctx->enc->capture_plane.waitForDQThread(1000);
@@ -456,4 +495,3 @@ int nvmpi_encoder_close(nvmpictx* ctx){
 	delete ctx->packet_pools;
 	delete ctx;
 }
-
